[inherit('common','psolr')]
program helpix2(input,output);

const
   MAX_PATHELMS = 10;

type
   shortstring = varying [255] of char;
   path = record
             npathelms : integer;
             pathelms : array [1..MAX_PATHELMS] of shortstring;
          end;

procedure insert(solr : solr_ctxptr; id : integer; currpath : path; helptext : pstr);

var
   totalpath : pstr;
   i : integer;

begin
   totalpath := '';
   for i := 1 to currpath.npathelms do begin
      if i > 1 then totalpath := totalpath + ' ';
      totalpath := totalpath + currpath.pathelms[i];
   end;
   psolr_insert(solr, id, 'path', totalpath, 'helptext', helptext);
   if (id mod 100) = 0 then begin
      writeln(id:1,' ',totalpath);
   end;
end;

var
   f : text;
   line : pstr;
   currpath : path;
   helptext : pstr;
   ix : integer;
   n : integer;
   solr : solr_ctxptr;
   id : integer;

begin
   solr := psolr_setup('arnepc5', 8888, 'vmshelp');
   psolr_delete(solr, '*:*');
   id := 1;
   helptext := '';
   open(f, 'helplib.hlp', old);
   reset(f);
   while not(eof(f)) do begin
      readln(f, line);
      n := length(line);
      while (n > 1) and (line[n] = ' ') do n := n - 1;
      line := substr(line, 1, n);
      if length(line) >= 2 then begin
         if (index('12345678', line[1]) > 0) and (line[2] = ' ') then begin
            if length(helptext) > 0 then begin
               insert(solr, id, currpath, helptext);
               helptext := '';
               id := id + 1;
            end;
            readv(substr(line, 1, 1), ix);
            currpath.npathelms := ix;
            n := 3;
            while (n < length(line)) and (line[n] = ' ') do n := n + 1;
            currpath.pathelms[ix] := substr(line, n, length(line) - n + 1);
         end else begin
            if (length(helptext) + length(line)) < 31800 then begin
               helptext := helptext + ' ' + line;
            end;
         end;
      end;
   end;
   if length(helptext) > 0 then begin
      insert(solr, id, currpath, helptext);
   end;
end.
